
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY top_level_tb IS
END top_level_tb;
ARCHITECTURE behavioral OF top_level_tb IS 

  COMPONENT top_level
  PORT( 
    CLK     :  IN  STD_LOGIC; 
    PWM	   :	IN	 STD_LOGIC; 

    FL	   :	IN	 STD_LOGIC; 
    FR	   :	IN  STD_LOGIC; 
	 
    LDR1	   :	IN	 STD_LOGIC; 
    LDR2	   :	IN	 STD_LOGIC; 
    LDR3	   :	IN	 STD_LOGIC; 
    LDR4    :	IN	 STD_LOGIC; 
	 
    LM_1	   :	OUT STD_LOGIC; 
    LM_0	   :	OUT STD_LOGIC; 
    LM_PWM	:	OUT STD_LOGIC; 
    RM_1	   :	OUT STD_LOGIC; 
    RM_0   	:	OUT STD_LOGIC; 
    RM_PWM	:	OUT STD_LOGIC);
   END COMPONENT;

   SIGNAL FL	:	STD_LOGIC;
   SIGNAL FR	:	STD_LOGIC;
   SIGNAL CLK	:	STD_LOGIC;
   SIGNAL PWM	:	STD_LOGIC;
   SIGNAL LDR1	:	STD_LOGIC;
   SIGNAL LDR2	:	STD_LOGIC;
   SIGNAL LDR3	:	STD_LOGIC;
   SIGNAL LDR4	:	STD_LOGIC;
   SIGNAL LM_1	:	STD_LOGIC;
   SIGNAL LM_0	:	STD_LOGIC;
   SIGNAL LM_PWM	:	STD_LOGIC;
   SIGNAL RM_1	:	STD_LOGIC;
   SIGNAL RM_0	:	STD_LOGIC;
   SIGNAL RM_PWM	:	STD_LOGIC;

BEGIN

  UUT: top_level PORT MAP(
  	 CLK => CLK, 
	 PWM => PWM, 
    FL => FL, 
    FR => FR, 
	 LDR1 => LDR1, 
	 LDR2 => LDR2, 
	 LDR3 => LDR3, 
	 LDR4 => LDR4, 
	 LM_1 => LM_1, 
	 LM_0 => LM_0, 
	 LM_PWM => LM_PWM, 
	 RM_1 => RM_1, 
	 RM_0 => RM_0, 
	 RM_PWM => RM_PWM );

   clock : PROCESS
   BEGIN
     CLK <= '0'; wait for 100 ns;
	  CLK <= '1'; wait for 100 ns;
   END PROCESS;
	
   speed : PROCESS
   BEGIN
     PWM <= '0'; wait for 30 ns;
	  PWM <= '1'; wait for 10 ns;
   END PROCESS;
	
   tb : PROCESS
   BEGIN
     FR <= '1'; FL <= '1';                    
	  LDR1 <= '1'; LDR2 <= '1'; LDR3 <= '1'; LDR4 <= '1';   -- explore
     wait for 2000 ns;
	  
     FR <= '1'; FL <= '1';
	  LDR1 <= '0'; LDR2 <= '0'; LDR3 <= '1'; LDR4 <= '1';   -- FRONT
     wait for 1000 ns;	  
     FR <= '1'; FL <= '1';
	  LDR1 <= '1'; LDR2 <= '1'; LDR3 <= '0'; LDR4 <= '0';   -- BACK
     wait for 1000 ns;
     FR <= '1'; FL <= '1';
	  LDR1 <= '0'; LDR2 <= '0'; LDR3 <= '1'; LDR4 <= '1';   -- FRONT
     wait for 1000 ns;	  
     FR <= '1'; FL <= '1';
	  LDR1 <= '1'; LDR2 <= '1'; LDR3 <= '1'; LDR4 <= '0';   -- BACK LEFT
     wait for 1000 ns;
	  FR <= '1'; FL <= '1';
	  LDR1 <= '0'; LDR2 <= '0'; LDR3 <= '1'; LDR4 <= '1';   -- FRONT
     wait for 1000 ns;	  
     FR <= '1'; FL <= '1';
	  LDR1 <= '1'; LDR2 <= '1'; LDR3 <= '0'; LDR4 <= '1';   -- BACK RIGHT
     wait for 1000 ns;
	  FR <= '1'; FL <= '1';
	  LDR1 <= '0'; LDR2 <= '0'; LDR3 <= '1'; LDR4 <= '1';   -- FRONT
     wait for 1000 ns;	  
     FR <= '1'; FL <= '1';
	  LDR1 <= '0'; LDR2 <= '1'; LDR3 <= '1'; LDR4 <= '1';   -- FRONT LEFT
     wait for 1000 ns;
	  FR <= '1'; FL <= '1';
	  LDR1 <= '0'; LDR2 <= '0'; LDR3 <= '1'; LDR4 <= '1';   -- FRONT
     wait for 1000 ns;	  
     FR <= '1'; FL <= '1';
	  LDR1 <= '1'; LDR2 <= '0'; LDR3 <= '1'; LDR4 <= '1';   -- FRONT RIGHT
     wait for 1000 ns;  
	  
     FR <= '1'; FL <= '0';
	  LDR1 <= '1'; LDR2 <= '1'; LDR3 <= '1'; LDR4 <= '1';   -- BUMPER LEFT
     wait for 1000 ns; 

     FR <= '0'; FL <= '1';
	  LDR1 <= '1'; LDR2 <= '1'; LDR3 <= '1'; LDR4 <= '1';   -- BUMPER RIGHT
     wait for 1000 ns; 
	  
     wait;
   END PROCESS;	

END;
